accounts/urls.py
from django.urls import path
from . import views

app_name = 'accounts'

urlpatterns = [
    path('login/', views.login_view, name = 'login_view'),
    path('logout/', views.logout_view, name = 'logout_view'),
    path('signup/', views.signup_view, name = 'signup_view'),
]

books/urls.py
from django.urls import path
from . import views

app_name = 'books'

urlpatterns = [
    path('', views.books_index, name = 'books_index'),
]

comment/urls.py
from . import views
from django.urls import path

app_name = 'comment'

urlpatterns = [
    path('', views.comment_list, name='comment_list'),
    path('comment_create/', views.comment_create, name="comment_create"),
    path('reply_create/<int:comment_id>/', views.reply_create, name="reply_create"),
    path("like/", views.like, name="like")
]

homepage/urls.py
from django.urls import path
from . import views

app_name = 'homepage'

urlpatterns = [
    path('', views.homepage_index, name = 'homepage_index'),
    path('about-me/', views.about_me, name = 'about_me')
]

story/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admintolhastolhasyeah/', admin.site.urls),
    path('', include('homepage.urls')),
    path('books/', include('books.urls')),
    path('accounts/', include('accounts.urls')),
    path('comment/', include('comment.urls')),
]

accounts/models.py
from django.db import models

# Create your models here.

books/models.py
from django.db import models

# Create your models here.

comment/models.py
from django.db import models
from django.contrib.auth.models import User

# Create your models here.
class Comment(models.Model):
    author = models.ForeignKey(User, on_delete=models.CASCADE, blank=True, null=True, )
    comment = models.TextField()
    created_at = models.DateTimeField(auto_now_add=True)

    def __str__(self):
        return "{} - {}".format(self.author, self.snipped_comment())

    def snipped_comment(self):
        if len(self.comment) > 20 :
            return self.comment[:20] + " ..."
        return self.comment

class Reply(models.Model):
    author = models.ForeignKey(User, on_delete=models.CASCADE, blank=True, null=True,)
    reply_live = models.TextField()
    created_at = models.DateTimeField(auto_now_add=True)
    comment = models.ForeignKey(Comment, on_delete=models.CASCADE, blank=True, null=True, related_name="replies")

    def __str__(self):
    	return "{} - {}".format(self.author, self.reply_live)

class Like(models.Model):
    username=models.ForeignKey(User, default=None, on_delete=models.CASCADE)

    def __str__(self):
        return str(self.username)

homepage/models.py
from django.db import models

# Create your models here.

comment/forms.py
from . import models
from django import forms


class CreateCommentForm(forms.ModelForm):
    comment = forms.CharField(widget=forms.Textarea(attrs={
            "class" : "md-textarea form-control",
            "required" : True,
            "rows":"3"
             }))
    class Meta:
           model = models.Comment
           fields=[
           "comment"]
           

class CreateReplyForm(forms.ModelForm):
    replies = forms.CharField(widget=forms.Textarea(attrs={
            "class" : "fields",
            "required" : True,
            "placeholder":"Balas komentar dia ^^",
             }))
    class Meta:
        model = models.Reply
        fields =[
        "replies",]

accounts/views.py
from django.shortcuts import render, redirect
from django.contrib.auth.forms import UserCreationForm, AuthenticationForm
from django.contrib.auth import login, logout
from django.contrib.auth.decorators import login_required
from django.views.decorators.csrf import csrf_protect

# Create your views here.

def signup_view(request):
	if request.method=="POST":
		form = UserCreationForm(request.POST)
		if form.is_valid():
			user=form.save()
			#log the user in
			login(request, user)
			return redirect("homepage:homepage_index")
	else:
		form = UserCreationForm()
	
	if request.method == "GET":
		if request.user.is_authenticated:
            # logic user
			return redirect ('homepage:homepage_index')
		else:
			return render(request, "accounts/signup.html", {"form": form})
	return render(request, "accounts/signup.html", {"form": form})
	


def login_view(request):
	if request.method=="POST":
		form=AuthenticationForm(data=request.POST)
		if form.is_valid():
			#log in the user
			user=form.get_user()
			login(request, user)
			return redirect("homepage:homepage_index")
	else:
		form=AuthenticationForm()
	return render(request, "accounts/login.html", {"form": form})

# @csrf_protect
@login_required
def logout_view(request):
	if request.method=="POST":
		logout(request)
		return redirect("homepage:homepage_index")
	return redirect("homepage:homepage_index")


        

books/views.py
from django.shortcuts import render
from django.http import HttpResponse, JsonResponse
import json
# import django.http.request

def books_index(request):
    return render (request, 'books/books.html')

comment/views.py
from django.shortcuts import render, redirect
from .models import Comment, Reply, Like
from .import forms
from django.contrib.auth.models import User
from django.contrib.auth.decorators import login_required


# Create your views here.


def comment_list(request):
    comments = Comment.objects.all()
    comment_form = forms.CreateCommentForm()
    reply_form = forms.CreateReplyForm()
    response = {
        'cmnt' : comments,
        'total_cmnt':len(comments),
        'form' : comment_form,
        'reply_form' : reply_form,
        'likes' : len(Like.objects.all()),
        'first3likes' : Like.objects.all()[:3],
        "restlike" : len(Like.objects.all())-3,

    }
    return render(request, 'comment/comment.html', response)

@login_required(login_url="accounts:login_view")
def comment_create(request):
    comment_form = forms.CreateCommentForm(request.POST)
    if request.method == "POST" and comment_form.is_valid():
        instance=comment_form.save(commit=False)
        instance.author = request.user
        instance.save()
        # Message.objects.create(
        #     message = message_form.cleaned_data['message'],
        # )
    return redirect('comment:comment_list')

@login_required(login_url="accounts:login_view")
def reply_create(request, comment_id):
    reply_form = forms.CreateReplyForm(request.POST)
    comment=Comment.objects.get(pk=comment_id)
    # Comment.objects.get(pk=comment_id).author
    if request.method == "POST" and reply_form.is_valid():
            instance=reply_form.save(commit=False)
            instance.author =request.user
            
            instance.reply_live = reply_form.cleaned_data["replies"]
            instance.comment=comment
            instance.save()
    return redirect('comment:comment_list')

@login_required(login_url="accounts:login_view")
def like(request):
    likers=request.user
    for lk in Like.objects.all():
        if lk.username == likers:
            return redirect("comment:comment_list")
    Like.objects.create(username = request.user)
    return redirect("comment:comment_list")

homepage/views.py
from django.shortcuts import render

def homepage_index(request):
    return render(request, 'homepage/index.html')

def about_me(request):
    return render(request, 'homepage/about_me.html')

accounts/templates/accounts/login.html
{% extends "base.html" %}
{% load static %}
{% block title %}Login{% endblock %}
{% block style %}
	<link href="{% static 'accounts/css/accounts.css' %}" rel="stylesheet">
{% endblock %}
{% block content %}
	<div class = "container">
		<form action="{% url 'accounts:login_view' %}" class="text-center border border-light p-5" method="post">
			<p class="h4 mb-4 mt-5" id="greeting_login">Login</p>
			{% csrf_token %}
			{{ form }}
			{% if request.GET.next %}
				<input type="hidden" name="next" value="{{ request.GET.next }}">
			{% endif %}	
			<button class="btn btn-info btn-block my-4" type="submit">Login</button>
			<p>Not a member?
				<a href="{% url 'accounts:signup_view' %}">Register</a>
			</p>
		</form>
	</div>	
{% endblock %}
{% block script %}
	<script>
		$(document).ready(function () {
			$("<br/>").insertAfter("input");
		});
	</script>
{% endblock %}

accounts/templates/accounts/signup.html
{% extends "base.html" %}
{% load static %}
{% block title %}Signup{% endblock %}
{% block style %}
	<link href="{% static 'accounts/css/accounts.css' %}" rel="stylesheet">    
{% endblock %}
{% block content %}

	<form action="{% url 'accounts:signup_view' %}" class="text-center border border-light p-5" method="post">
		<p class="h4 mb-4 mt-5 signup" id="greeting_signup">Signup</p>
		{% csrf_token %}
		{{ form }}
		{% if request.GET.next %}
			<input type="hidden" name="next" value="{{request.GET.next}}">
		{% endif %}	
		<button class="btn btn-info btn-block my-4" type="submit">Signup</button>
	</form>
	
{% endblock %}
{% block script %}
	<script>
		$(document).ready(function () {
			$("<br/>").insertAfter("input");
		});
	</script>
{% endblock %}

books/templates/books/books.html
{% extends "base.html" %}
{% load static %}
{% block title %}Books{% endblock %}
{% block style %}
    <link href="{% static 'books/css/books.css' %}" rel="stylesheet">
{% endblock %}
{% block content %}

    <!--Main layout-->
    <main class="container">
        <div class = "text-center">
            <h1 id = "greeting_books" class="books-head h1-responsive wow bounce text-center mt-5">Find your book here!</h1>	
        </div>

        <!--Section: search-->
        <section id="search" class="py-5">
            <div class = "d-flex justify-content-center">
                <form class="form-search row ml-sm-2 ml-xs-5 mr-2 form-search form-inline md-form form-sm active-purple active-purple-2 mt-2">
                    <input class="form-control form-control-sm" id = "search_field" type="text" placeholder="Search book here..." aria-label="Search">
                </form>
                <button type="button" class="btn btn-info p-2" id = "search-button">
                        <i class="fas fa-search" aria-hidden="true"></i>
                </button>
            </div>  
        </section>
        <!--Section: search-->

        <div class = "wow slideInUp">
            
            <!--Section: list_books-->
            <section id = "list_books" class = "row">
                
            </section>
            <!--Section: list_books-->
        </div>
    </main>
    <!--Main layout-->
{% endblock %}

{% block script %}
    <script type="text/javascript" src="{% static 'books/js/books.js' %}"></script>
{% endblock %}

comment/templates/comment/comment.html
{% extends "base.html" %}
{% load static %}
{% block title %}Contact Me{% endblock %}
{% block style %}
    <link href="{% static 'comment/css/comment.css' %}" rel="stylesheet">
{% endblock %}
{% block content %}

<main class="container py-5">
    <h2 class="h1-responsive mb-5 mt-3 section-title">Write Your Comments :D</h2>

    <div class="d-flex justify-content-center">
        <div>
            <div class="sub_msg_like_box text-center">
                <h3>{{ likes }}</h3>
                <p class="sub_msg_like_box_desc">
                    {% if likes > 1 %}
                        Likes
                    {% else %}
                        Like
                    {% endif %}
                </p>
            </div>

            <form action="{% url 'comment:like' %}" method="POST">
                {% csrf_token %}
                <button type="submit" class = "btn btn-pink btn-block btn-rounded z-depth-1">
                    LIKE
                </button>
            </form>  
                
            <p>
                {% if likes > 0 %}
                    {% for lk in first3likes %} 
                        {{ lk.username }}, 
                    {% endfor %}
                    {% if restlike >= 1 %}
                        dan {{ restlike }} orang lainnya
                    {% endif %}
                    menyukai website ini.
                {% endif %}    
            </p>
        </div>
    </div>
    <h4 class = "h4-responsive">{{ total_cmnt }} Comment(s)</h4>
    <!-- <div class="md-form">
        <textarea id="form7" class="md-textarea form-control" rows="3"></textarea>
        
    </div> -->
    <form action="{% url 'comment:comment_create' %}" method="POST" class="sub_msg_comment">
        {% csrf_token %}
        <div class = "md-form">
            {% for field in form.visible_fields %}
                {{ field }}
            {% endfor %}
            <label for="id_comment">Add your Comment Here</label>
        </div>
        <button type="submit" class = "btn btn-blue btn-block btn-rounded z-depth-1">Add!</button>
    </form>

        {% for comment in cmnt %}
                <!-- <div class="sub_msg_thecomment_reply" id="{{comment.created_at}}"> 
                <div class="targetreplying" id="replybox{{comment.created_at}}">
                <div class="sub_msg_thecomment_reply_commentsection_content_wrapper" id="sembunyikan{{comment.created_at}}">
                <div class="canceled_reply" id="canceled{{comment.created_at}}">
                <div class="sub_msg_thecomment_reply_commentsection_title cf"> -->
                <div class="card mb-4">
                    <div class="card-header">
                        <p class = "time-stamp m-0"><strong>{{ comment.author.username }}</strong> commented on {{ comment.created_at }}</p>
                    </div>
                    <div class="card-body">
                        <p class="card-text">{{ comment.comment }}</p>
                    </div>
                </div>

                    <!-- <h6>{{ comment.author.username }}</h6>
                    <span>{{ comment.created_at }}</span>
                </div>
                <p>{{ comment.comment }}</p>
                <p class="replybox"><a href="#replybox{{comment.created_at}}">Balas</a></p>
                <form method="POST" action="{% url 'comment:reply_create' comment_id=comment.id %}" class="sub_msg_thecomment_reply_replysection_button cf">
                        {% csrf_token %}
                    <div>
                            {% for field in reply_form.visible_fields %}
                            {{ field }}
                        {% endfor %}
                        <button type="submit" method="POST" class="reply_me">Balas</button>
                        <p class="batal"><a href="#canceled{{comment.created_at}}">Batal</a></p>
                    </div> -->
                
                <!-- reply content section -->
                <!-- </form>
                <p class="lihat_balasan"><a href="#{{comment.created_at}}" >lihat balasan</a></p>
                <p class="sembunyikan_balasan"><a href="#sembunyikan{{comment.created_at}}">sembunyikan balasan</a></p>
                <div class="sub_msg_thecomment_reply_commentsection_content">
                    <p class="balasan">Balasan:</p>
                    {% for reply in comment.replies.all %}
                    <div>
                        {{ reply.reply_live }} oleh <span class="reply_author">{{ reply.author.username }}</span> pada {{reply.created_at}}
                    </div>
                    {% endfor %}
                </div>
                </div>
                </div>
                </div>
            </div> -->
            
        {% endfor %}
    </main>

    <!--Section: contact-->
    <section id="contact" class="py-5">

        <div class="container">

        <div class="connect-box">
            <h2 class="h1-responsive mb-5 mt-3 section-title white-text">Contact Me</h2>

            <div class="ml-3">
            <div class="row d-flex justify-content-center">
                <i class="col-2 fa fa-phone fa-2x white-text"></i>
                <p class = "col-8 white-text">+6281381472780</p>
            </div>

            <div class="row d-flex justify-content-center">
                <i class="col-2 fa fa-envelope fa-2x white-text"></i>
                <p class = "col-8 white-text">jonathantolhas@gmail.com</p>
            </div>

            <div class="row d-flex justify-content-center">
                <i class="col-2 fa fa-map-marker fa-2x white-text"></i>
                <p class = "col-8 white-text">Jalan Alam Asri III No. 21, Pondok
                    Pinang, Kebayoran Lama, Jakarta
                    Selatan, DKI Jakarta, Indonesia
                </p>
            </div>
            </div>
        </div>
        </div>
    </section>
    <!--Section: contact-->

{% endblock %}

homepage/templates/homepage/index.html
{% extends "base.html" %}
{% load static %}
{% block title %}Tolhas's Website{% endblock %}
{% block style %}
    <link href="{% static 'homepage/css/homepage.css' %}" rel="stylesheet">
{% endblock %}
{% block content %}
    <!-- Jumbotron -->
    <div class="jumbotron">
        <div class="d-flex justify-content-center align-items-center">
            <!-- Content -->
            <div class="container-fluid">
                <div class="row wow fadeIn">
                    <div class="col-md-12 mb-4 white-text text-left wow fadeInLeft">
                        {% if user.is_authenticated %}
                        <h1 id = "greetings-user" class="h1-responsive display-3 font-weight-bold white-text mb-0 pt-md-5 pt-5">Hello {{user.username}}!</h1>
                        {% else %}
                        <h1 class="h1-responsive display-3 font-weight-bold white-text mb-0 pt-md-5 pt-5">Hello!</h1>
                        {% endif %}
                        <h4 class="subtext-header-responsive mt-2 mb-4" id = 'greeting'>I'm Tolhas Parulian Jonathan</h4>
                    </div>
                </div>
                <div class="wow fadeInRight d-flex justify-content-end intro-img-container">
                    <img src="{% static 'homepage/img/Tolhas.png' %}" alt="Tolhas Intro" class="img-fluid intro-img">
                </div>
            </div>
        </div>
    </div>
    <!-- Full Page Intro -->

    <!--Main layout-->
    <main class="container">
        <div class="d-flex justify-content-around wow fadeIn circle-skills-group">
            <div class="circle-skills h4-responsive d-flex align-items-center justify-content-center">
                IT Enthusiast
            </div>
            <div class="circle-skills h4-responsive d-flex align-items-center justify-content-center">
                Optimistic
            </div>
            <div class="circle-skills h4-responsive d-flex align-items-center justify-content-center">
                Creative
            </div>
        </div>

        
    </main>
    <!--Main layout-->
{% endblock %}

{% block script %}
    <script type="text/javascript" src="{% static 'homepage/js/homepage.js' %}"></script>
{% endblock %}

templates/base.html
<!DOCTYPE html>
{% load static %}
<html lang="en">

<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  <meta http-equiv="x-ua-compatible" content="ie=edge">
  <title>
    {% block title %}{% endblock %} 
  </title>
  <!-- Font Awesome -->
  <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.8.2/css/all.css" >
  <!-- Bootstrap core CSS -->
  <link href="{% static 'css/bootstrap.min.css' %}" rel="stylesheet">
  <!-- Material Design Bootstrap -->
  <link href="{% static 'css/mdb.min.css' %}" rel="stylesheet">
  <link href="{% static 'css/style.css' %}" rel="stylesheet">
  {% block style %}{% endblock %}
</head>

<body>
    <!--first-backdrop-->
    <div id="first-backdrop">
        <h1 class="white-text h1-responsive opening-1"><strong>IT Enthusiast</strong></h1>
        <h1 class="white-text h1-responsive opening-2"><strong>Optimistic</strong></h1>
        <h1 class="white-text h1-responsive opening-3"><strong>Creative</strong></h1>
    </div>
    
    <!-- Main navigation -->
    <header>
      <!-- Navbar -->
      <nav class="navbar navbar-expand-lg navbar-dark fixed-top scrolling-navbar primary-color navbar-writing">
          <div class="container">
              {% if user.is_authenticated %}
                  <a class="navbar-brand mb-1" href="{% url 'homepage:homepage_index' %}">{{user.username}}</a>
              {% else %}
                  <a class="navbar-brand" href="{% url 'homepage:homepage_index' %}">Tolhas</a>
              {% endif %}
              <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarToggler"
                  aria-controls="navbarToggler" aria-expanded="false" aria-label="Toggle navigation">
                  <span class="navbar-toggler-icon"></span>
              </button>
              <div class="collapse navbar-collapse" id="navbarToggler">
                  <ul class="navbar-nav mr-auto smooth-scroll">
                      <li class="nav-item">
                          <a class="nav-link" href="{% url 'homepage:homepage_index' %}#home">Home</a>
                      </li>
                      <li class="nav-item">
                        <a class="nav-link" href="{% url 'homepage:about_me' %}">About Me</a>
                      </li>
                      <li class="nav-item">
                        <a class="nav-link" href="{% url 'comment:comment_list' %}">Contact Me</a>
                      </li>
                      <li class="nav-item">
                          <a class="nav-link" href="{% url 'books:books_index' %}">Searching for Books?</a>
                      </li>
                      {% if user.is_authenticated %}
                        <li class="nav-item">
                            <form action="{% url 'accounts:logout_view' %}" method="post">
                                    {% csrf_token %}
                                    <button type="submit" class="nav-link" id = "logout">Logout</button>
                            </form>
                        </li>
                      {% else %}
                         <li class="nav-item">
                            <a class="nav-link" href="{% url 'accounts:login_view' %}">Login</a>
                        </li>
                        <li class="nav-item">
                                <a class="nav-link" href="{% url 'accounts:signup_view' %}">Signup</a>
                        </li>
                      {% endif %}
                  </ul>
                  <!-- Social Icon  -->
                  <ul class="navbar-nav nav-flex-icons">
                      <li class="nav-item">
                          <a class="nav-link" href="https://www.facebook.com/tolhas.jonathan.7">
                              <i class="fab fa-facebook light-green-text-2"></i>
                          </a>
                      </li>
                      <li class="nav-item">
                          <a class="nav-link" href="https://github.com/tolhassianipar">
                              <i class="fab fa-github light-green-text-2"></i>
                          </a>
                      </li>
                      <li class="nav-item d-flex align-items-center m-2">
                          <label class="switch m-0 p-0">
                              <input type="checkbox" id = 'theme'>
                              <span class="slider round"></span>
                          </label>
                          <p class = "m-0 ml-1 mr-1 text-white" id = "change-theme">Ubah Tema</p>
                          <i class="fas fa-moon"></i>
                      </li>
                  </ul>
              </div>
          </div>
      </nav>
      <!-- Navbar -->

    </header>

    <div class="body-container">
        {% block content %}
        {% endblock %}
    </div>

   <!-- Footer -->
    <footer class="page-footer font-small pt-4">

            <div class="container">
                <ul class="list-unstyled list-inline text-center">
                    <li class="list-inline-item">
                    <a class="btn-floating btn-fb mx-1" href="https://www.facebook.com/tolhas.jonathan.7">
                        <i class="fab fa-facebook"> </i>
                    </a>
                    </li>
                    <li class="list-inline-item">
                    <a class="btn-floating btn-li mx-1" href="https://www.linkedin.com/in/tolhas-jonathan-9a810a180">
                        <i class="fab fa-linkedin"> </i>
                    </a>
                    </li>
                    <li class="list-inline-item">
                        <a class="btn-floating btn-li mx-1" href="https://github.com/tolhassianipar">
                            <i class="fab fa-github"></i>   
                        </a>
                    </li>
                </ul>        
            </div>    

            <!-- Copyright -->
            <div class="footer-copyright text-center py-3">Tolhas's Website Reference:
                GSGS
            </div>
    </footer>

    <button onclick="topFunction()" id="myBtn" title="back to top" class = "btn btn-secondary">
        <i class="fas fa-arrow-up"></i>
    </button>

    <!-- SCRIPTS -->
    
    <!-- JQuery -->
    <script type="text/javascript" src="{% static 'js/jquery-3.4.1.min.js' %}"></script>
    <!-- Bootstrap tooltips -->
    <script type="text/javascript" src="{% static 'js/popper.min.js' %}"></script>
    <!-- Bootstrap core JavaScript -->
    <script type="text/javascript" src="{% static 'js/bootstrap.min.js' %}"></script>
    <!-- MDB core JavaScript -->
    <script type="text/javascript" src="{% static 'js/mdb.min.js' %}"></script>
    <script type="text/javascript" src="{% static 'js/base.js' %}"></script>
    <!-- <script>
        if (window.performance) {
            alert("Browser Supports");
        }
        if (performance.navigation.type == 1) {
            alert("Reloaded"); 
        } else {
            alert("Not Reloaded"); 
        }
    </script> -->
    {% block script %}
    {% endblock %}
</body>

</html>